/*
 * XLife Copyright 1989 Jon Bennett jb7m+@andrew.cmu.edu, jcrb@cs.cmu.edu
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <ctype.h>

#include "defs.h"

#if STATEBITS == 4
bool is_state(char c) {
   return isdigit(c) || c <= 'F' && c >= 'A';
}

int stoi(char c) {
   return isdigit(c) ? (c) - '0' : (c) - '7';
}

char itos(int n) {
   return (n) < 10 ? '0' + (n) : '7' + (n);
}
#endif

char saveformat = 'M';
int inputwwidth;

/* X I/O state information */
Display *disp;
Window rootw, mainw, lifew, helpw, inputw, coordw, rulew;
int screen;
unsigned long fcolor, bcolor;
XEvent event;
XFontStruct *nfont, *bfont;
GC ntextgc, btextgc,inputgc,cellgc[MAXSTATES],xorgc;
KeySym ks;

#define INPBUFLEN 255
char inpbuf[INPBUFLEN];
int minbuflen;
#define DIRBUFLEN 100
int numcomments;
#define MAXCOMMENTS 256
char comments[MAXCOMMENTS][256];
char loadirbuf[DIRBUFLEN];
char keybuf[16];
char lookup[0xfffff];
char fname[256];

#if STATEBITS > 1
unsigned int maxstates;
#endif /* STATEBITS > 1 */

coord_t xpos,ypos;       /* coords of upper left corner of viewport */
coord_t xorigin, yorigin;/* virtual origin */
coord_t lastx, lasty;    /* last coord pair displayed on status line */
coord_t loadx, loady;    /* location to load new points */
coord_t iloadx, iloady;  /* initial location of load points */
int txx, txy, tyx, tyy;  /* transform for tentative points */

bool dispboxes;
long scale;
unsigned long born;
unsigned long live;

int width, height;
int inputlength;
int state;
bool dispcoord;
struct timeval timeout;

#if STATEBITS == 1
#define paintcolor 1
#else
int paintcolor;
char active_rules[100];
#endif

int inputwwidth;
#ifdef PROF
int link_called;
int link_search;
int create_called;
int create_null;
#endif /* PROF */

int oldp, qdirs;
char *dirs[MAXDIRS];
unsigned delay;